package org.amse.mARICa.autoTests;

import java.io.File;
import java.util.ArrayList;

import org.amse.mARICa.model.*;
import org.amse.mARICa.model.impl.Board;
import org.amse.mARICa.game.*;
import org.amse.mARICa.ioXML.*;

import junit.framework.*;

public class MyTests extends TestCase {
	
	private int myHeight;
	private int myWidth;
	private IBoard myBoard;
	private IGame myGame;
	char myLabyrinth [][];

	/**
	 *   getCell()  setWall()
	 */
	public void test1 (){
		Board board = new Board(5, 7);
		board.setWall(0, 0);
		assertTrue("Verify: setWall(0,0)  getCell()",  board.getCell(0, 0) instanceof IWall ); 
		//	 System.out.println("Success test 1. Verify: setWall(0,0)  getCell()");
		//else System.out.println("Error test 1. Verify: setWall(0,0)  getCell()");
	}
	

	/**
	 *  getCell()  setFreeCell()
	 */
	public void test2 (){
		Board board = new Board(5, 7);
		board.setFreeCell(0, 0);
		
		assertTrue(  board.getCell(0, 0) instanceof IFreeCell ); 
	//		 System.out.println("Success test 2. Verify: setFreeCell(0,0)  getCell()");
	//	else System.out.println("Error test 2. Verify: setFreeCell(0,0)  getCell()");
	}

	/**
	 *  setWall()  setFreeCell() getCell() 
	 */
	public void test3() {
		Board board = new Board(5, 7);
		board.setFreeCell(0, 0);
		board.setWall(0, 1);
		boolean bool = (board.getCell(0, 0) instanceof IFreeCell);
		bool = bool && (board.getCell(0, 1) instanceof IWall);
		assertTrue( bool ); 
		//	 System.out.println("Success test 3. Verify: setWall(0,1)  setFreeCell(0,0)  getCell()");
		//else System.out.println("Error test 3. Verify: setWall(0,1)  setFreeCell(0,0)  getCell()");
	}
	
	/**
	 *  setFreeCell() getCell() setStore() isStore()
	 */
	public void test4() {
		Board board = new Board(5, 7);
		board.setFreeCell(0, 0);
		( (IFreeCell) board.getCell(0, 0)).setStore(true);
		
		assertTrue ( ( (IFreeCell) board.getCell(0, 0)).isStore() ) ;
		//	 System.out.println("Success test 4. Verify: setFreeCell(0,0) getCell() setStore(true) isStore()");
		//else System.out.println("Error test 4. Verify: setFreeCell(0,0) getCell() setStore(true) isStore()");
	}
	
	/**
	 *  setFreeCell() getCell() setStore() setBox() entity()
	 */
	public void test5() {
		Board board = new Board(5, 7);
		board.setFreeCell(0, 0);
		( (IFreeCell) board.getCell(0, 0)).setStore(true);
		( (IFreeCell) board.getCell(0, 0)).setBox();
		boolean bool = ( (IFreeCell) board.getCell(0, 0)).isStore();
		bool = bool && (( (IFreeCell) board.getCell(0, 0)).entity() instanceof IBox);
		assertTrue ( bool ) ;
		//	 System.out.println("Success test 5. Verify: setFreeCell(0,0) getCell() setStore(true) setBox() entity()");
		//else System.out.println("Error test 5. Verify: setFreeCell(0,0) getCell() setStore(true) setBox() entity()");
	}
	
	/**
	 *  setFreeCell() getCell() setStore() setBox() entity()
	 */
	public void test6() {
		Board board = new Board(5, 7);
		board.setFreeCell(0, 0);
		( (IFreeCell) board.getCell(0, 0)).setStore(false);
		( (IFreeCell) board.getCell(0, 0)).setBox();
		boolean bool = !( (IFreeCell) board.getCell(0, 0)).isStore();
		bool = bool && (( (IFreeCell) board.getCell(0, 0)).entity() instanceof IBox);
		assertTrue ( bool ) ;
		//	 System.out.println("Success test 6. Verify: setFreeCell(0,0) getCell() setStore(false) setBox() entity()");
		//else System.out.println("Error test 6. Verify: setFreeCell(0,0) getCell() setStore(false) setBox() entity()");
	}
	
	/**
	 *  setFreeCell() getCell() setStore() setMan() entity()
	 */
	public void test7() {
		Board board = new Board(5, 7);
		board.setFreeCell(0, 0);
		( (IFreeCell) board.getCell(0, 0)).setStore(true);
		( (IFreeCell) board.getCell(0, 0)).setMan();
		boolean bool = ( (IFreeCell) board.getCell(0, 0)).isStore();
		bool = bool && (( (IFreeCell) board.getCell(0, 0)).entity() instanceof IMan);
		assertTrue ( bool ); 
		//	 System.out.println("Success test 7. Verify: setFreeCell(0,0) getCell() setStore(true) setMan() entity()");
		//else System.out.println("Error test 7. Verify: setFreeCell(0,0) getCell() setStore(true) setMan() entity()");
	}
	
	/**
	 *  setFreeCell() getCell() setStore() setMan() entity()
	 */
	public void test8() {
		Board board = new Board(5, 7);
		board.setFreeCell(0, 0);
		( (IFreeCell) board.getCell(0, 0)).setStore(false);
		( (IFreeCell) board.getCell(0, 0)).setMan();
		boolean bool = !( (IFreeCell) board.getCell(0, 0)).isStore();
		bool = bool && (( (IFreeCell) board.getCell(0, 0)).entity() instanceof IMan);
		assertTrue ( bool ) ;
		//	 System.out.println("Success test 8. Verify: setFreeCell(0,0) getCell() setStore(faslse) setMan() entity()");
		//else System.out.println("Error test 8. Verify: setFreeCell(0,0) getCell() setStore(false) setMan() entity()");
	}

	//     
	private String verifyStr(char labyrinth [][]){
		StringBuffer str = new StringBuffer();
		for (int i = 0; i < myHeight; i++){
			for (int j = 0; j < myWidth; j++)
				switch (labyrinth[i][j]){
				case 'W': str.append("| |");break;
				case 'F': str.append(" . ");break;
				case 'S': str.append(" S ");break;
				case 'B': str.append(" B ");break;
				case 'O': str.append(" O ");break;
				case 'M': str.append(" M ");break;
				case 'L': str.append(" L ");break;
				case 'N': str.append(" N ");break;
				}
			str.append("\n");
			}
		return str.toString();
	}	
    // 
	private void setBoard(){
		for(int i = 0; i < myHeight; i++)
			for(int j = 0; j < myWidth; j++){
				switch (myLabyrinth[i][j]){
				case 'W':
					myBoard.setWall(i, j); break;
				case 'F': 
					myBoard.setFreeCell(i, j); break;				
				case 'S':
					myBoard.setFreeCell(i, j);
					( (IFreeCell) myBoard.getCell(i, j)).setStore(true);break;
				case 'B':
					myBoard.setFreeCell(i, j);
					( (IFreeCell) myBoard.getCell(i, j)).setBox();break;
				case 'M':
					myBoard.setFreeCell(i, j);
					( (IFreeCell) myBoard.getCell(i, j)).setMan();break;	
				case 'O':
					myBoard.setFreeCell(i, j);
					( (IFreeCell) myBoard.getCell(i, j)).setStore(true);
					( (IFreeCell) myBoard.getCell(i, j)).setBox();break;
				case 'L':
					myBoard.setFreeCell(i, j);
					( (IFreeCell) myBoard.getCell(i, j)).setStore(true);
					( (IFreeCell) myBoard.getCell(i, j)).setMan();break;
				}					
			}
	}
    //    
	private String getBoard(){
		StringBuffer out = new StringBuffer();
		for(int i=0; i<myBoard.getHeight(); i++){
			for(int j=0; j<myBoard.getWidth(); j++){
				if ( myBoard.getCell(i, j) instanceof IFreeCell )
					if (( (IFreeCell) myBoard.getCell(i, j)).isStore())
						if (( (IFreeCell) myBoard.getCell(i, j)).entity() instanceof IBox)
							out.append(" O ");//  
						else
							if (( (IFreeCell) myBoard.getCell(i, j)).entity() instanceof IMan)
								out.append(" L ");//  
							else
								out.append(" S ");//
					else {
						if (( (IFreeCell) myBoard.getCell(i, j)).entity()== null)
							out.append(" . ");// ,  ,  
						else
							if (( (IFreeCell) myBoard.getCell(i, j)).entity() instanceof IBox)
								out.append(" B ");//
							else
								out.append(" M ");;//
					}
				else
					if ( myBoard.getCell(i, j) instanceof IWall )
						out.append("| |");
					else 
						out.append(" N ");//  
			}
			out.append("\n");
		}
		return out.toString();
	}

	private void initForLabir1() {
		myHeight = 9;
		myWidth = 12;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6   7   8   9   10  11
		 {{'W','W','W','W','W','W','W','W','W','W','W','W'},//0
          {'W','F','F','W','F','F','W','F','S','S','S','W'},//1
          {'W','F','F','W','F','B','W','F','F','F','F','W'},//2
          {'W','F','B','W','F','F','W','F','F','W','W','W'},//3
          {'W','F','F','F','F','F','W','F','F','F','M','W'},//4
          {'W','F','F','F','F','F','W','F','F','F','F','W'},//5
          {'W','W','W','W','F','F','B','F','F','W','F','W'},//6
          {'W','F','F','F','F','F','F','F','F','W','F','W'},//7
          {'W','W','W','W','W','W','W','W','W','W','W','W'}};//8 
	}	
	private void initForLabir2() {
		myHeight = 11;
		myWidth = 11;
		myLabyrinth = new char [][]
		//	0   1   2   3   4   5   6   7   8   9   10
		 {{'N','N','N','W','W','W','W','W','N','N','N'},//0
		  {'N','N','N','W','F','S','F','W','N','N','N'},//1
          {'N','N','N','W','F','F','F','W','N','N','N'},//2
	      {'W','W','W','W','F','F','F','W','W','W','W'},//3	                              
          {'W','F','F','F','F','F','F','F','F','F','W'},//4
		  {'W','S','F','F','F','L','F','F','F','O','W'},//5
          {'W','F','F','F','F','F','F','F','F','F','W'},//6
		  {'W','W','W','W','F','S','F','W','W','W','W'},//7
          {'N','N','N','W','F','F','F','W','N','N','N'},//8
          {'N','N','N','W','F','F','F','W','N','N','N'},//9
	      {'N','N','N','W','W','W','W','W','N','N','N'}};//10 
	}
	private void initForLabir21() {
		//right board
		myHeight = 11;
		myWidth = 11;
		myLabyrinth = new char [][]
		//	0   1   2   3   4   5   6   7   8   9   10
		 {{'N','N','N','W','W','W','W','W','N','N','N'},//0
		  {'N','N','N','W','F','S','F','W','N','N','N'},//1
          {'N','N','N','W','F','F','F','W','N','N','N'},//2
	      {'W','W','W','W','F','F','F','W','W','W','W'},//3	                              
          {'W','F','F','F','F','B','F','F','F','F','W'},//4
		  {'W','S','F','F','B','L','B','F','F','O','W'},//5
          {'W','F','F','F','F','F','F','F','F','F','W'},//6
		  {'W','W','W','W','F','S','F','W','W','W','W'},//7
          {'N','N','N','W','F','B','F','W','N','N','N'},//8
          {'N','N','N','W','F','F','F','W','N','N','N'},//9
	      {'N','N','N','W','W','W','W','W','N','N','N'}};//10 
	}
	private void initForLabir31() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'W','W','W','W','W','W','W'},//0
          {'W','F','F','F','F','F','W'},//1
          {'W','F','W','W','W','F','W'},//2
          {'W','F','W','N','W','F','W'},//3
          {'W','F','W','W','W','F','W'},//4
          {'W','F','F','F','F','F','W'},//5
          {'W','W','W','W','W','W','W'}};//6 
	}
	private void initForLabir32() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'W','W','W','W','W','W','W'},//0
          {'W','F','F','F','F','F','W'},//1
          {'W','F','W','W','W','F','W'},//2
          {'W','F','W','N','W','F','W'},//3
          {'W','F','W','F','W','F','W'},//4
          {'W','F','F','F','F','F','W'},//5
          {'W','W','W','W','W','W','W'}};//6 
	}	
	private void initForLabir33() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'N','N','W','W','W','N','N'},//0
          {'N','N','W','F','W','N','N'},//1
          {'W','W','F','F','F','W','W'},//2
          {'W','F','F','F','F','F','W'},//3
          {'W','W','F','F','F','W','W'},//4
          {'N','N','W','F','W','N','N'},//5
          {'N','N','W','W','W','N','N'}};//6 
	}	
	private void initForLabir34() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'W','W','W','W','W','W','W'},//0
          {'W','F','F','F','F','F','W'},//1
          {'W','F','F','N','F','F','W'},//2
          {'W','F','N','N','F','F','W'},//3
          {'W','F','F','N','F','F','W'},//4
          {'W','F','F','F','F','F','W'},//5
          {'W','W','W','W','W','W','W'}};//6 
	}	
	private void initForLabir35() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'W','W','W','W','W','W','W'},//0
          {'W','N','N','N','N','N','W'},//1
          {'W','N','N','N','N','N','W'},//2
          {'W','N','N','N','N','N','W'},//3
          {'W','N','N','N','N','N','W'},//4
          {'W','N','N','N','N','N','W'},//5
          {'W','W','W','W','W','W','W'}};//6 
	}	
	private void initForLabir36() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'W','W','W','W','W','W','W'},//0
          {'W','F','F','F','F','F','W'},//1
          {'W','F','F','F','F','F','W'},//2
          {'W','F','F','F','F','F','W'},//3
          {'W','F','F','F','F','F','W'},//4
          {'W','F','F','F','F','F','W'},//5
          {'W','W','W','W','W','W','W'}};//6 
	}	
	private void initForLabir37() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'W','W','W','W','W','W','W'},//0
          {'W','W','W','W','W','W','W'},//1
          {'W','W','W','W','W','W','W'},//2
          {'W','W','W','W','W','W','W'},//3
          {'W','W','W','W','W','W','W'},//4
          {'W','W','W','W','W','W','W'},//5
          {'W','W','W','W','W','W','W'}};//6 
	}
	private void initForLabir38() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'F','F','F','F','F','F','F'},//0
          {'F','F','F','F','F','F','F'},//1
          {'F','F','F','F','F','F','F'},//2
          {'F','F','F','F','F','F','F'},//3
          {'F','F','F','F','F','F','F'},//4
          {'F','F','F','F','F','F','F'},//5
          {'F','F','F','F','F','F','F'}};//6 
	}
	private void initForLabir39() {
		myHeight = 7;
		myWidth = 7;
		myLabyrinth = new char [][]		
		  //0   1   2   3   4   5   6
		 {{'F','F','F','F','F','F','F'},//0
          {'F','F','F','F','F','F','F'},//1
          {'F','F','F','F','F','F','F'},//2
          {'F','S','F','F','B','M','F'},//3
          {'F','F','F','F','F','F','F'},//4
          {'F','F','F','F','F','F','F'},//5
          {'F','F','F','F','F','F','F'}};//6 
	}
	private void initForLabir4() {
		myHeight = 11;
		myWidth = 14;
		myLabyrinth = new char [][]	
  		//	0   1   2   3   4   5   6   7   8   9   10  11  12  13
         {{'N','W','W','W','W','W','N','N','N','N','N','N','N','N'},//0
		  {'N','W','F','F','W','W','W','W','W','W','W','W','W','W'},//1
		  {'N','W','F','F','F','F','F','F','F','F','F','F','F','W'},//2
		  {'N','W','F','W','W','W','W','W','W','W','W','F','F','W'},//3	                              
		  {'N','W','F','W','S','F','F','F','F','F','W','F','W','W'},//4
		  {'N','W','F','W','S','F','F','F','B','F','W','B','W','N'},//5
		  {'W','W','F','W','S','F','F','F','F','F','W','M','W','N'},//6
		  {'W','F','F','W','W','W','W','W','F','F','W','B','W','N'},//7
		  {'W','F','F','F','F','F','F','F','F','F','F','F','W','N'},//8
		  {'W','W','W','W','W','W','W','W','F','F','F','F','W','N'},//9
		  {'N','N','N','N','N','N','N','W','W','W','W','W','W','N'}};//10
	}
	
	private void initForLabir41() {//  ,   box   
		myHeight = 11;
		myWidth = 14;
		myLabyrinth = new char [][]	
  		//	0   1   2   3   4   5   6   7   8   9   10  11  12  13
         {{'N','W','W','W','W','W','N','N','N','N','N','N','N','N'},//0
		  {'N','W','F','F','W','W','W','W','W','W','W','W','W','W'},//1
		  {'N','W','F','F','F','F','F','F','F','B','M','B','F','W'},//2
		  {'N','W','F','W','W','W','W','W','W','W','W','F','F','W'},//3	                              
		  {'N','W','F','W','S','F','F','F','F','F','W','F','W','W'},//4
		  {'N','W','F','W','S','F','F','F','B','F','W','F','W','N'},//5
		  {'W','W','F','W','S','F','F','F','F','F','W','F','W','N'},//6
		  {'W','F','F','W','W','W','W','W','F','F','W','F','W','N'},//7
		  {'W','F','F','F','F','F','F','F','F','F','F','F','W','N'},//8
		  {'W','W','W','W','W','W','W','W','F','F','F','F','W','N'},//9
		  {'N','N','N','N','N','N','N','W','W','W','W','W','W','N'}};//10
	}

	
	public void test10() {
		initForLabir1();			
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		String str = getBoard();
		String strVer = verifyStr(myLabyrinth);
		assertEquals ( str, strVer); 
		//	 System.out.println("Success test 10. Verify: Set and Get All Board");
		//else System.out.println("Error test 10. Verify: Set and Get All Board");
	}
	
	public void test11() {
		initForLabir2();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		String str = getBoard();
		String strVer = verifyStr(myLabyrinth);
		assertEquals ( str, strVer); 
		//	 System.out.println("Success test 11. Verify: Set and Get All Board");
		//else System.out.println("Error test 11. Verify: Set and Get All Board");
	}
	
	public void test12() {
		initForLabir1();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertTrue ( myBoard.isValid() ); 
		//	 System.out.println("Success test 12. Verify: isValid of right Board (Labir1)");
		//else System.out.println("Error test 12. Verify: isValid of right Board (Labir1)");
	}
	
	public void test13() {
		initForLabir2();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertFalse ( myBoard.isValid() ); 
		//	 System.out.println("Success test 13. Verify: isValid of right form Board and wrong Store-Box(Labir2)");
		//else System.out.println("Error test 13. Verify: isValid of right form Board and wrong Store-Box(Labir2)");
	}
	
	public void test131() {
		initForLabir31();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertTrue ( myBoard.isValid() ) ;
	//		 System.out.println("Success test 13.1 . Verify: isValid of right form Board (Labir31)");
	//	else System.out.println("Error test 13.1 . Verify: isValid of right form Board (Labir31)");
	}	
	public void test132() {
		initForLabir32();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertFalse(myBoard.isValid() ); 
		//	 System.out.println("Success test 13.2 . Verify: isValid of unright form Board (Labir32)");
	//	else System.out.println("Error test 13.2 . Verify: isValid of unright form Board (Labir32)");
	}	
	public void test133() {
		initForLabir33();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertFalse ( myBoard.isValid() ); 
		//	 System.out.println("Success test 13.3 . Verify: isValid of unright form Board (Labir33)");
		//else System.out.println("Error test 13.3 . Verify: isValid of unright form Board (Labir32)");
	}	
	public void test134() {
		initForLabir34();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertFalse ( myBoard.isValid() ); 
		//	 System.out.println("Success test 13.4 . Verify: isValid of unright form Board (Labir34)");
	//	else System.out.println("Error test 13.4 . Verify: isValid of unright form Board  (Labir34)");
	}	
	public void test135() {
		initForLabir35();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertTrue ( myBoard.isValid() ); 
		//	 System.out.println("Success test 13.5 . Verify: isValid of right form Board (Labir35)");
		//else System.out.println("Error test 13.5 . Verify: isValid of right form Board (Labir35)");
	}
	public void test136() {
		initForLabir36();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertTrue ( myBoard.isValid() ) ;
	//		 System.out.println("Success test 13.6 . Verify: isValid of right form Board (Labir36)");
	//	else System.out.println("Error test 13.6 . Verify: isValid of right form Board (Labir36)");
	}
	public void test137() {
		initForLabir37();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertTrue ( myBoard.isValid() ) ;
	//		 System.out.println("Success test 13.7 . Verify: isValid of right form Board (Labir37)");
		//else System.out.println("Error test 13.7 . Verify: isValid of right form Board (Labir37)");
	}
	public void test138() {
		initForLabir38();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertFalse(myBoard.isValid() ); 
			 //System.out.println("Success test 13.8 . Verify: isValid of unright form Board (Labir38)");
		//else System.out.println("Error test 13.8 . Verify: isValid of unright form Board (Labir38)");
	}
	
	public void test14() {
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		assertTrue( myBoard.isValid() ) ;
	//		 System.out.println("Success test 14 . Verify: isValid of right form Board (Labir4)");
	//	else System.out.println("Error test 14 . Verify: isValid of right form Board (Labir4)");
	}
	
	public void test15(){
		//  Game -  
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		char ChangeLabyrinth [][] = new char [][]
	//	0   1   2   3   4   5   6   7   8   9   10  11  12  13
	 {{'N','W','W','W','W','W','N','N','N','N','N','N','N','N'},//0
	  {'N','W','F','F','W','W','W','W','W','W','W','W','W','W'},//1
	  {'N','W','F','F','F','F','F','F','F','F','F','F','F','W'},//2
	  {'N','W','F','W','W','W','W','W','W','W','W','F','F','W'},//3	                              
	  {'N','W','F','W','S','F','F','F','F','F','W','B','W','W'},//4
	  {'N','W','F','W','S','F','F','F','B','F','W','M','W','N'},//5
	  {'W','W','F','W','S','F','F','F','F','F','W','F','W','N'},//6
	  {'W','F','F','W','W','W','W','W','F','F','W','B','W','N'},//7
	  {'W','F','F','F','F','F','F','F','F','F','F','F','W','N'},//8
	  {'W','W','W','W','W','W','W','W','F','F','F','F','W','N'},//9
	  {'N','N','N','N','N','N','N','W','W','W','W','W','W','N'}};//10
		// =  
		String strVer = verifyStr(ChangeLabyrinth);
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		int may = myGame.canGo(Direction.UP); 
		switch (may){
		case 1: 
			myGame.goBox(Direction.UP);
			myGame.goMan(Direction.UP);	
			break;
		case 0: 
			myGame.goMan(Direction.UP);	
			break;
		};		
		String GetingStr = getBoard(); 
		assertEquals(GetingStr, strVer);
	}
	
	public void test16(){
		//  Game -  
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		char ChangeLabyrinth [][] = new char [][]
	//	0   1   2   3   4   5   6   7   8   9   10  11  12  13
	 {{'N','W','W','W','W','W','N','N','N','N','N','N','N','N'},//0
	  {'N','W','F','F','W','W','W','W','W','W','W','W','W','W'},//1
	  {'N','W','F','F','F','F','F','F','F','F','F','F','F','W'},//2
	  {'N','W','F','W','W','W','W','W','W','W','W','F','F','W'},//3	                              
	  {'N','W','F','W','S','F','F','F','F','F','W','F','W','W'},//4
	  {'N','W','F','W','S','F','F','F','B','F','W','B','W','N'},//5
	  {'W','W','F','W','S','F','F','F','F','F','W','F','W','N'},//6
	  {'W','F','F','W','W','W','W','W','F','F','W','M','W','N'},//7
	  {'W','F','F','F','F','F','F','F','F','F','F','B','W','N'},//8
	  {'W','W','W','W','W','W','W','W','F','F','F','F','W','N'},//9
	  {'N','N','N','N','N','N','N','W','W','W','W','W','W','N'}};//10
		// =  
		String strVer = verifyStr(ChangeLabyrinth);
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		int may = myGame.canGo(Direction.DOWN); 
		switch (may){
		case 1:
		  myGame.goBox(Direction.DOWN);
		  myGame.goMan(Direction.DOWN);
		  break;
		case 0:
		  myGame.goMan(Direction.DOWN);
		  break;
		};
		String GetingStr = getBoard(); 
		assertEquals(GetingStr, strVer);
	}
	
	public void test17(){
		//  Game -  
		initForLabir41();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		char ChangeLabyrinth [][] = new char [][]
	//	0   1   2   3   4   5   6   7   8   9   10  11  12  13
	 {{'N','W','W','W','W','W','N','N','N','N','N','N','N','N'},//0
	  {'N','W','F','F','W','W','W','W','W','W','W','W','W','W'},//1
	  {'N','W','F','F','F','F','F','F','B','M','F','B','F','W'},//2
	  {'N','W','F','W','W','W','W','W','W','W','W','F','F','W'},//3	                              
	  {'N','W','F','W','S','F','F','F','F','F','W','F','W','W'},//4
	  {'N','W','F','W','S','F','F','F','B','F','W','F','W','N'},//5
	  {'W','W','F','W','S','F','F','F','F','F','W','F','W','N'},//6
	  {'W','F','F','W','W','W','W','W','F','F','W','F','W','N'},//7
	  {'W','F','F','F','F','F','F','F','F','F','F','F','W','N'},//8
	  {'W','W','W','W','W','W','W','W','F','F','F','F','W','N'},//9
	  {'N','N','N','N','N','N','N','W','W','W','W','W','W','N'}};//10
		// =  
		String strVer = verifyStr(ChangeLabyrinth);
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(2,10));
		int may = myGame.canGo(Direction.LEFT); 
		switch (may){
		case 1: 
			myGame.goBox(Direction.LEFT);
			myGame.goMan(Direction.LEFT);
			break;
		case 0: 
			myGame.goMan(Direction.LEFT);
			break;
		};
		String GetingStr = getBoard(); 
		assertEquals(GetingStr, strVer);
	}
	
	public void test18(){
		//  Game -  
		initForLabir41();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		char ChangeLabyrinth [][] = new char [][]
	//	0   1   2   3   4   5   6   7   8   9   10  11  12  13
	 {{'N','W','W','W','W','W','N','N','N','N','N','N','N','N'},//0
	  {'N','W','F','F','W','W','W','W','W','W','W','W','W','W'},//1
	  {'N','W','F','F','F','F','F','F','F','B','F','M','B','W'},//2
	  {'N','W','F','W','W','W','W','W','W','W','W','F','F','W'},//3	                              
	  {'N','W','F','W','S','F','F','F','F','F','W','F','W','W'},//4
	  {'N','W','F','W','S','F','F','F','B','F','W','F','W','N'},//5
	  {'W','W','F','W','S','F','F','F','F','F','W','F','W','N'},//6
	  {'W','F','F','W','W','W','W','W','F','F','W','F','W','N'},//7
	  {'W','F','F','F','F','F','F','F','F','F','F','F','W','N'},//8
	  {'W','W','W','W','W','W','W','W','F','F','F','F','W','N'},//9
	  {'N','N','N','N','N','N','N','W','W','W','W','W','W','N'}};//10
		// =  
		String strVer = verifyStr(ChangeLabyrinth);
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(2,10));
		int may = myGame.canGo(Direction.RIGHT); 
		switch (may){
		case 1: 
			myGame.goBox(Direction.RIGHT);
			myGame.goMan(Direction.RIGHT);	
			break;
		case 0: 
			myGame.goMan(Direction.RIGHT);	
			break;
		};
		String GetingStr = getBoard(); 
		assertEquals(GetingStr, strVer);
	}
	
	public void test19(){
		//isAllBoxOnStore
		myHeight = 11;
		myWidth = 14;
		myLabyrinth = new char [][]	
	  		//	0   1   2   3   4   5   6   7   8   9   10  11  12  13
	         {{'N','W','W','W','W','W','N','N','N','N','N','N','N','N'},//0
			  {'N','W','F','F','W','W','W','W','W','W','W','W','W','W'},//1
			  {'N','W','F','F','F','F','F','F','F','F','F','F','F','W'},//2
			  {'N','W','F','W','W','W','W','W','W','W','W','F','F','W'},//3	                              
			  {'N','W','F','W','O','F','F','F','F','F','W','F','W','W'},//4
			  {'N','W','F','W','O','F','F','F','B','F','W','F','W','N'},//5
			  {'W','W','F','W','O','F','F','F','F','F','W','M','W','N'},//6
			  {'W','F','F','W','W','W','W','W','F','F','W','F','W','N'},//7
			  {'W','F','F','F','F','F','F','F','F','F','F','F','W','N'},//8
			  {'W','W','W','W','W','W','W','W','F','F','F','F','W','N'},//9
			  {'N','N','N','N','N','N','N','W','W','W','W','W','W','N'}};//10
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		assertTrue(myGame.isAllBoxOnStore());
	}
	
	private void moveOneStep(Direction dir){
		if (myGame.canGo(dir) >= 0){
			if (myGame.canGo(dir) > 0){
				 if (myGame.goBox(dir)){
					if (myGame.isAllBoxOnStore())
						;/*myWin = true;*/
				 }
			}//myGame.canGo(dir) == 0  
			myGame.goMan(dir);
		}
	}
	
	public void test20(){
		// UnDo()
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		moveOneStep(Direction.UP);
		moveOneStep(Direction.UP);
		moveOneStep(Direction.UP);
		myGame.unDo();
		char ChangeLabyrinth [][] = new char [][]
        //	0   1   2   3   4   5   6   7   8   9   10  11  12  13
	   {{'N','W','W','W','W','W','N','N','N','N','N','N','N','N'},//0
		{'N','W','F','F','W','W','W','W','W','W','W','W','W','W'},//1
		{'N','W','F','F','F','F','F','F','F','F','F','F','F','W'},//2
		{'N','W','F','W','W','W','W','W','W','W','W','B','F','W'},//3	                              
		{'N','W','F','W','S','F','F','F','F','F','W','M','W','W'},//4
		{'N','W','F','W','S','F','F','F','B','F','W','F','W','N'},//5
		{'W','W','F','W','S','F','F','F','F','F','W','F','W','N'},//6
		{'W','F','F','W','W','W','W','W','F','F','W','B','W','N'},//7
		{'W','F','F','F','F','F','F','F','F','F','F','F','W','N'},//8
		{'W','W','W','W','W','W','W','W','F','F','F','F','W','N'},//9
	    {'N','N','N','N','N','N','N','W','W','W','W','W','W','N'}};//10
		// =  
		String strVer = verifyStr(ChangeLabyrinth);
		String GetingStr = getBoard(); 
		//System.out.print(GetingStr);
		//System.out.println();
		//System.out.print(strVer);
		assertEquals(GetingStr, strVer);
	}
	
	public void test21(){
		// 3*UnDo()
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		// =   -   ,    
		String strVer = verifyStr(myLabyrinth);
		moveOneStep(Direction.UP);
		moveOneStep(Direction.UP);
		moveOneStep(Direction.UP);
		myGame.unDo();
		myGame.unDo();
		myGame.unDo();
		String GetingStr = getBoard(); 
		//System.out.print(GetingStr);
		//System.out.println();
		//System.out.print(strVer);
		assertEquals(GetingStr, strVer);
	}
	
	public void test22(){
		// Step,Step, (=) Step; UnDo, UnDo; ReDo (=)
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		moveOneStep(Direction.UP);
		moveOneStep(Direction.UP);
		// =  
		String strVer = getBoard();
		moveOneStep(Direction.UP);
		myGame.unDo();
		myGame.unDo();
		myGame.reDo();
		String GetingStr = getBoard(); 
		//System.out.print(GetingStr);
		//System.out.println();
		//System.out.print(strVer);
		assertEquals(GetingStr, strVer);
	}
	
	public void test23(){
		// Step,Step,Step (=); UnDo, UnDo, UnDo; ReDo, ReDo,ReDo (=)
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		moveOneStep(Direction.UP);
		moveOneStep(Direction.UP);
		moveOneStep(Direction.UP);
		// =  
		String strVer = getBoard();
		myGame.unDo();
		myGame.unDo();
		myGame.unDo();
		myGame.reDo();
		myGame.reDo();
		myGame.reDo();
		String GetingStr = getBoard(); 
		//System.out.print(GetingStr);
		//System.out.println();
		//System.out.print(strVer);
		assertEquals(GetingStr, strVer);
	}
	
	public void test24(){
		//   Redo   
		// Step,Step,(=) Step; UnDo, UnDo; Step (=) ReDo=FALSE
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		moveOneStep(Direction.UP);
		moveOneStep(Direction.UP);
		// =  
		String strVer = getBoard();
		moveOneStep(Direction.UP);
		myGame.unDo();
		myGame.unDo();
		moveOneStep(Direction.UP);
		String GetingStr = getBoard(); 			
		//System.out.print(GetingStr);
		//System.out.println();
		//System.out.print(strVer);	
		assertFalse(myGame.reDo());
		assertEquals(GetingStr, strVer);
	}
	
	public void test25(){
		//  UnDo   
		// UnDo=FALSE
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		assertFalse(myGame.unDo());
	}
	
	public void test26(){
		//  ReDo   
		// ReDo=FALSE
		initForLabir4();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		Point Stores [] = new Point [3];
		Stores[0]=new Point(4,4);
		Stores[1]=new Point(5,4);
		Stores[2]=new Point(6,4);
		myGame = new Game(myBoard, Stores, new Point(6,11));
		assertFalse(myGame.reDo());
	}
	
	public void test27XML(){
		initForLabir1();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		try{
			AbstractWriter writer = new BoardWriter(myBoard, myBoard.getHeight(),myBoard.getWidth(),3,96);
			writer.writeXmlFile("board1.clv");
			assertTrue(true);
		}catch (WriterException e){
			System.out.println(e.getMessage());
			assertTrue(false);
		}
	}
	
	public void test28XML(){
		initForLabir21();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		try{
			AbstractWriter writer = new BoardWriter(myBoard, myBoard.getHeight(),myBoard.getWidth(),5,21);
			writer.writeXmlFile("board2.clv");
			assertTrue(true);
		}catch (WriterException e){
			System.out.println(e.getMessage());
			assertTrue(false);
		}
	}
	public void test280XML(){
		initForLabir39();
		myBoard = new Board (myHeight, myWidth);
		setBoard();
		try{
			AbstractWriter writer = new BoardWriter(myBoard, myBoard.getHeight(),myBoard.getWidth(),5,21);
			writer.writeXmlFile("boardForRule.clv");
			assertTrue(true);
		}catch (WriterException e){
			System.out.println(e.getMessage());
			assertTrue(false);
		}
	}
	
	public void test29XML(){
		try{ 
			Reader reader = new Reader(new File("board1.clv"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard(); 
			int countStores = data.getCountStores();
			Point Stores [] = data.getStores();
			Point startPos = data.getStartPos();
			assertTrue(myBoard.isValid());
			assertEquals(3, countStores);
			assertEquals(new Point(4,10),startPos);
			assertEquals(new Point(1,8),Stores[0]);
			assertEquals(new Point(1,9),Stores[1]);
			assertEquals(new Point(1,10),Stores[2]);
			String strXML = getBoard();
			//     
			initForLabir1();			
			myBoard = new Board (myHeight, myWidth);
			setBoard();
			String strArray = getBoard();
			//System.out.println(strArray);
			//System.out.println(strXML);
			assertEquals ( strXML, strArray);
		}catch (ReaderException e){
			System.out.println(e.getMessage());
			assertTrue(false);
		}		
	}
	
	public void test30XML(){
		try{
			Reader reader = new Reader(new File("board2.clv"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
			int countStores = data.getCountStores();
			Point Stores [] = data.getStores();
			Point startPos = data.getStartPos();
			assertTrue(myBoard.isValid());
			assertEquals(5, countStores);
			assertTrue( startPos.equals(new Point(5,5)) );			
			assertTrue(Stores[0].equals(new Point(1,5)) );
			assertTrue(Stores[1].equals(new Point(5,1)) );
			assertTrue(Stores[2].equals(new Point(5,5)) );			
			assertTrue(Stores[3].equals(new Point(5,9)) );
			assertTrue(Stores[4].equals(new Point(7,5)) );
			String strXML = getBoard();
			//     
			initForLabir21();			
			myBoard = new Board (myHeight, myWidth);
			setBoard();
			String strArray = getBoard();
			//System.out.println(strArray);
			//System.out.println(strXML);
			assertEquals ( strXML, strArray);
		}catch (ReaderException e){
			System.out.println(e.getMessage());
			assertTrue(false);
		}		
	}
	
	public void test31XML(){
		try{
			Reader reader = new Reader(new File("left boards\\Lb1.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
		}catch (ReaderException e){
			System.out.println("empty file " + e.getMessage());
			assertFalse(false);
		}	
	}
	public void test32XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB2.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
			assertFalse(myBoard.isValid());
		}catch (ReaderException e){
			System.out.println("test32XML (invalid board) " + e.getMessage());
			assertFalse(false);
		}	
	}
	public void test33XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB3.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
		}catch (ReaderException e){
			System.out.println("test33XML (  ) " + e.getMessage());
			assertFalse(false);
		}	
	}
	public void test34XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB4.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
		}catch (ReaderException e){
			System.out.println("test34XML ( <minStep count=''114''/>) " + e.getMessage());
			assertFalse(false);
		}	
	}
	public void test35XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB5.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
		}catch (ReaderException e){
			System.out.println("test35XML (<board height=''9.32''>) " + e.getMessage());
			assertFalse(false);
		}	
	}
	public void test36XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB6.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
		}catch (ReaderException e){
			System.out.println("test36XML ( </board>) " + e.getMessage());
			assertFalse(false);
		}	
	}
	public void test37XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB7.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
		}catch (ReaderException e){
			System.out.println("test37XML ( </board>) " + e.getMessage());
			assertFalse(false);
		}	
	}
	public void test38XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB8.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
			System.out.println("test38XML (<board height='9' count='456' width='12'>) -  ");
			assertTrue(true);
		}catch (ReaderException e){
			System.out.println("test38XML (<board height='9' count='456' width='12'>) " + e.getMessage());
			assertFalse(false);
		}	
	}	
	public void test39XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB9.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
			System.out.println("test39XML (<call>) -   ");
			assertTrue(true);
		}catch (ReaderException e){
			System.out.println("test39XML (<call>) " + e.getMessage());
			assertFalse(false);
		}	
	}
	
	public void test40XML(){
		try{
			Reader reader = new Reader(new File("left boards\\LB10.xml"));
			DataForGame data = reader.setBoardFromDoc();
			myBoard = data.getBoard();
			System.out.println("test40XML ( <cell x=1 y=2/> == <wall x=1 y=1/>  ");
			assertTrue(true);
		}catch (ReaderException e){
			System.out.println("test40XML ( <cell x=1 y=2/> == <wall x=1 y=1/>  " + e.getMessage());
			assertFalse(false);
		}	
	}
	
	public void test41XML(){
		ArrayList<Score> arrScore = new ArrayList<Score>();
		arrScore.add(0, new Score("Clever mool","5"));
		arrScore.add(1, new Score("Clever mool","4"));
		arrScore.add(2, new Score("Clever mool","3"));
		arrScore.add(3, new Score("Clever mool","2"));
		arrScore.add(4, new Score("Clever mool","1"));
		try{
			AbstractWriter writer = new ScoresWriter(arrScore);
			writer.writeXmlFile("scores.dat");
			assertTrue(true);
		}catch (WriterException e){
			System.out.println(e.getMessage());
			assertTrue(false);
		}
	}
	
	public void test42XML(){
		ArrayList<Score> arrScore = null;
		try{
			Reader reader = new Reader(new File("scores.dat"));
			arrScore = reader.setScoresFromDoc();
			int i = 5;
			for(Score score: arrScore){
				assertEquals("Clever mool" , score.getName());
				assertEquals(((Integer)i).toString() , score.getScore());
				i--;
			}
		}catch (ReaderException e){
			System.out.println(e.getMessage());
			assertTrue(false);
		}		
	}
	  
	public void test43XML(){
		try{
			Reader reader = new Reader(new File("board1.xml"));
			reader.setScoresFromDoc();
		}catch (ReaderException e){
			System.out.println(e.getMessage());
			assertFalse(false);
		}		
	}
	

}
