package org.amse.mARICa.game;

import org.amse.mARICa.model.*;
import java.util.*;

public class Game implements IGame {
	
	/**
	 *    
	 * [x][y] -    
	 * moveBox -       
	 * @author mARICa
	 */
	private class Step{
		int x;
		int y;
		boolean moveBox = false;
	}
	
	/**
	 *  
	 */
	private IBoard myBoard;
	/**
	 *   
	 * [0] -   
	 */
	private ArrayList<Step> mySteps;
	/**
	 *       
	 *      
	 */
	private Step myNewStep;	
	/**
	 *   ,    
	 *   
	 */
	private int myCurrentPos;
	
	/**
	 *   
	 */
	private Point [] Stores;
	/**
	 *   
	 */
	private int countStep;
	
	public Game(IBoard board, Point [] stores, Point startPos){
		myBoard = board;
		Stores = stores;
		myNewStep = new Step();
		myNewStep.x = startPos.x;
		myNewStep.y = startPos.y;
		//   (      100
		mySteps = new ArrayList<Step>(100);
		//  -  
		mySteps.add(myNewStep);
	}

	public boolean isAllBoxOnStore() {
		for(int i=0; i < Stores.length; i++){
			if (!( ((IFreeCell)myBoard.getCell(Stores[i].x, Stores[i].y)).entity() instanceof IBox  ))
				return false;			
		}
		return true;
	}

	public boolean reDo() {
		//        
		// ,   unDo  
		if (myCurrentPos+1 == mySteps.size())
			return false;
		int xOld = mySteps.get(myCurrentPos).x;
		int yOld = mySteps.get(myCurrentPos).y;
		int xNew = mySteps.get(++myCurrentPos).x;
		int yNew = mySteps.get(myCurrentPos).y;
		Direction dir = null;
		//  
		if (yNew < yOld) dir = Direction.RIGHT;
		if (yNew > yOld) dir = Direction.LEFT;
		if (xNew < xOld) dir = Direction.UP;
		if (xNew > xOld) dir = Direction.DOWN;
		
		if (mySteps.get(myCurrentPos).moveBox){
			//   
			switch (dir){
			case LEFT:
				( (IFreeCell)myBoard.getCell(xNew, yNew+1)).moveEntity(
				  ( (IFreeCell)myBoard.getCell(xNew, yNew)).entity() );
				( (IFreeCell)myBoard.getCell(xNew, yNew)).moveEntity(null);break;
			case RIGHT:
				( (IFreeCell)myBoard.getCell(xNew, yNew-1)).moveEntity(
				  ( (IFreeCell)myBoard.getCell(xNew, yNew)).entity() );
				( (IFreeCell)myBoard.getCell(xNew, yNew)).moveEntity(null);break;
			case DOWN:
				( (IFreeCell)myBoard.getCell(xNew+1, yNew)).moveEntity(
				  ( (IFreeCell)myBoard.getCell(xNew, yNew)).entity() );
				( (IFreeCell)myBoard.getCell(xNew, yNew)).moveEntity(null);break;
			case UP:
				( (IFreeCell)myBoard.getCell(xNew-1, yNew)).moveEntity(
				  ( (IFreeCell)myBoard.getCell(xNew, yNew)).entity() );
				( (IFreeCell)myBoard.getCell(xNew, yNew)).moveEntity(null);break;
			}
		}
		// 
		( (IFreeCell)myBoard.getCell(xNew, yNew)).moveEntity(
				( (IFreeCell)myBoard.getCell(xOld, yOld)).entity() );
		( (IFreeCell)myBoard.getCell(xOld, yOld)).moveEntity(null);		
		countStep++;
		return true;
	}

	public boolean unDo() {
		if (myCurrentPos == 0)
			return false;
		int xOld = mySteps.get(myCurrentPos).x;
		int yOld = mySteps.get(myCurrentPos).y;
		int xNew = mySteps.get(--myCurrentPos).x;
		int yNew = mySteps.get(myCurrentPos).y;
		Direction dir = null;
		//  
		if (yNew > yOld) dir = Direction.RIGHT;
		if (yNew < yOld) dir = Direction.LEFT;
		if (xNew > xOld) dir = Direction.UP;
		if (xNew < xOld) dir = Direction.DOWN;
		
		( (IFreeCell)myBoard.getCell(xNew, yNew)).moveEntity(
				( (IFreeCell)myBoard.getCell(xOld, yOld)).entity() );
		if (! mySteps.get(myCurrentPos+1).moveBox)
			//    
			( (IFreeCell)myBoard.getCell(xOld, yOld)).moveEntity(null);
		else//   -       Cell' Board'
			switch (dir){
			case LEFT:
				( (IFreeCell)myBoard.getCell(xOld, yOld)).moveEntity(
				  ( (IFreeCell)myBoard.getCell(xOld, yOld+1)).entity() );
				( (IFreeCell)myBoard.getCell(xOld, yOld+1)).moveEntity(null);break;
			case RIGHT:
				( (IFreeCell)myBoard.getCell(xOld, yOld)).moveEntity(
				  ( (IFreeCell)myBoard.getCell(xOld, yOld-1)).entity() );
				( (IFreeCell)myBoard.getCell(xOld, yOld-1)).moveEntity(null);break;
			case DOWN:
				( (IFreeCell)myBoard.getCell(xOld, yOld)).moveEntity(
				  ( (IFreeCell)myBoard.getCell(xOld+1, yOld)).entity() );
				( (IFreeCell)myBoard.getCell(xOld+1, yOld)).moveEntity(null);break;
			case UP:
				( (IFreeCell)myBoard.getCell(xOld, yOld)).moveEntity(
				  ( (IFreeCell)myBoard.getCell(xOld-1, yOld)).entity() );
				( (IFreeCell)myBoard.getCell(xOld-1, yOld)).moveEntity(null);break;
			}
		countStep++;
		return true;
	}

	public int canGo(Direction dir) {
		int x1=0, y1=0, x2=0, y2=0;
		
		switch (dir) {
		case LEFT:
			x1 = mySteps.get(myCurrentPos).x;
			y1 = mySteps.get(myCurrentPos).y-1;
			x2 = mySteps.get(myCurrentPos).x;
			y2 = mySteps.get(myCurrentPos).y-2;
			break;
		case RIGHT:
			x1 = mySteps.get(myCurrentPos).x;
			y1 = mySteps.get(myCurrentPos).y+1;
			x2 = mySteps.get(myCurrentPos).x;
			y2 = mySteps.get(myCurrentPos).y+2;
			break;
		case DOWN:
			x1 = mySteps.get(myCurrentPos).x+1;
			y1 = mySteps.get(myCurrentPos).y;
			x2 = mySteps.get(myCurrentPos).x+2;
			y2 = mySteps.get(myCurrentPos).y;
			break;
		case UP:
			x1 = mySteps.get(myCurrentPos).x-1;
			y1 = mySteps.get(myCurrentPos).y;
			x2 = mySteps.get(myCurrentPos).x-2;
			y2 = mySteps.get(myCurrentPos).y;
			break;
		}
		
		//1, 1 -      ,     - ,      
		if ( (x2 < 0)|| (x2 >= myBoard.getHeight()) || (y2 < 0) || (y2 >= myBoard.getWidth()) ){
			return -1;
		}
		
		ICell cell1 = myBoard.getCell(x1, y1);
		ICell cell2 = myBoard.getCell(x2, y2);
		
		if (cell1 instanceof IWall){
			return -1;
		}else if ( ((IFreeCell)cell1).entity() instanceof IBox ){
				if ( cell2 instanceof IWall){
					return -1;
				}else if ( ((IFreeCell)cell2).entity() instanceof IBox ){
					return -1;
				} else {
					return 1;
				}
		}
		return 0;
	}



	public boolean goBox(Direction dir) {
		//      ,   
		int x = mySteps.get(myCurrentPos).x;
		int y = mySteps.get(myCurrentPos).y;
		myNewStep = new Step();
		myNewStep.moveBox = true;
		switch (dir){
			case LEFT:
				y--;
				( (IFreeCell)myBoard.getCell(x, y-1)).moveEntity(
						( (IFreeCell)myBoard.getCell(x, y)).entity() );
				( (IFreeCell)myBoard.getCell(x, y--)).moveEntity(null);
				break;
			case RIGHT:
				y++;
				( (IFreeCell)myBoard.getCell(x, y+1)).moveEntity(
						( (IFreeCell)myBoard.getCell(x, y)).entity() );
				( (IFreeCell)myBoard.getCell(x, y++)).moveEntity(null);
				break;
			case DOWN:
				x++;
				( (IFreeCell)myBoard.getCell(x+1, y)).moveEntity(
						( (IFreeCell)myBoard.getCell(x, y)).entity() );
				( (IFreeCell)myBoard.getCell(x++, y)).moveEntity(null);
				break;
			case UP:
				x--;
				( (IFreeCell)myBoard.getCell(x-1, y)).moveEntity(
						( (IFreeCell)myBoard.getCell(x, y)).entity() );
				( (IFreeCell)myBoard.getCell(x--, y)).moveEntity(null);
				break;
			}
		// switch    -    
		return ( (IFreeCell)myBoard.getCell(x, y)).isStore();		
	}
	

	public void goMan(Direction dir) {
		int x = mySteps.get(myCurrentPos).x;
		int y = mySteps.get(myCurrentPos).y;
		//,    
		//  ,      Step
		if (myNewStep == mySteps.get(myCurrentPos) )
			myNewStep = new Step();
		switch (dir) {
		case LEFT:
			( (IFreeCell)myBoard.getCell(x, y-1)).moveEntity(
					( (IFreeCell)myBoard.getCell(x, y)).entity() );
			( (IFreeCell)myBoard.getCell(x, y)).moveEntity(null);
			myNewStep.x = x;
			myNewStep.y = y-1;
			break;
		case RIGHT:
			( (IFreeCell)myBoard.getCell(x, y+1)).moveEntity(
					( (IFreeCell)myBoard.getCell(x, y)).entity() );
			( (IFreeCell)myBoard.getCell(x, y)).moveEntity(null);
			myNewStep.x = x;
			myNewStep.y = y+1;
			break;
		case DOWN:
			( (IFreeCell)myBoard.getCell(x+1, y)).moveEntity(
					( (IFreeCell)myBoard.getCell(x, y)).entity() );
			( (IFreeCell)myBoard.getCell(x, y)).moveEntity(null);
			myNewStep.x = x+1;
			myNewStep.y = y;
			break;
		case UP:
			( (IFreeCell)myBoard.getCell(x-1, y)).moveEntity(
					( (IFreeCell)myBoard.getCell(x, y)).entity() );
			( (IFreeCell)myBoard.getCell(x, y)).moveEntity(null);
			myNewStep.x = x-1;
			myNewStep.y = y;
			break;
		}		
		mySteps.add(++myCurrentPos, myNewStep);
		//   ,    
		//    
		if (myCurrentPos+1 < mySteps.size())
			for(int i= mySteps.size()-1; i > myCurrentPos; i--)
				mySteps.remove(i);
		countStep++;
		
	}

	public int getCountStep() {
		return countStep;
	}

	public boolean canRedo() {
		//        
		// ,   unDo  
		return myCurrentPos+1 != mySteps.size();
	}

	public boolean canUndo() {
		return myCurrentPos != 0;
	}
}

