package org.amse.mARICa.ioXML;

import java.io.*;

import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;

import org.w3c.dom.*;

public abstract class AbstractWriter {
	
	Document myDoc;	
	
	protected Document createDomDocument() {
        try {
            DocumentBuilder builder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
            Document doc = builder.newDocument();
            return doc;
        } catch (ParserConfigurationException e) {
        }
        return null;
    }
	
	/**
	 *    DOM document    
	 * @param filename
	 */
    public void writeXmlFile(String filename) {
        try {
            // Prepare the DOM document for writing
            Source source = new DOMSource(myDoc);
    
            // Prepare the output file
            File file = new File(filename);
            Result result = new StreamResult( new OutputStreamWriter(new FileOutputStream(file), "utf-8"));
    
            // Write the DOM document to the file
            TransformerFactory factory = TransformerFactory.newInstance();
            
            factory.setAttribute("indent-number", new Integer(8));
           
            Transformer xformer = factory.newTransformer();
            
            xformer.setOutputProperty(OutputKeys.INDENT, "yes");
            
            xformer.transform(source, result);
            
        } catch (TransformerConfigurationException e) {
        	throw new WriterException("   XML");
        } catch (TransformerException e) {
        	throw new WriterException("   XML");
        } catch (IOException e) {
        	throw new WriterException("   XML");
        }
    }
}
