package org.amse.mARICa.ioXML;

import org.amse.mARICa.model.*;
import org.w3c.dom.*;

public class BoardWriter extends AbstractWriter {

	IBoard myBoard;
	
	/**
	 *    Document'  Board
	 * @param board
	 * @param height
	 * @param width
	 * @param countStores
	 */
	public BoardWriter(IBoard board,int height, int width, int countStores, int minStep){
		myBoard = board;
		myDoc = createDomDocument();
	    if (myDoc == null){
	    	throw new WriterException("   XML");
	    }
	    //Insert the root element node
	    Element elBoard = myDoc.createElement("board");
	    elBoard.setAttribute("height", ((Integer)height).toString());
	    elBoard.setAttribute("width", ((Integer)width).toString());
	    myDoc.appendChild(elBoard);
	   
	    Element elMinStep = myDoc.createElement("minStep");
	    elMinStep.setAttribute("count", ((Integer)minStep).toString());
	    elBoard.appendChild(elMinStep);
	    
	    Element elStore = myDoc.createElement("store");
	    elStore.setAttribute("count",  ((Integer)countStores).toString());
	    elBoard.appendChild(elStore);   
	    setDocBoard(board,height, width);
	}
	
	private void setDocBoard(IBoard board,int height, int width){
		Element elCell;
		for(int i = 0; i < height; i++){
			for(int j = 0; j < width; j++){
				ICell cell = myBoard.getCell(i, j);
				if (cell == null){
					;
				} else if (cell instanceof IWall) {
					elCell = myDoc.createElement("wall");
					elCell.setAttribute("x",((Integer)i).toString() );
					elCell.setAttribute("y",((Integer)j).toString() );
					myDoc.getDocumentElement().appendChild(elCell);
				} else {//cell instanceof FreeCell
					elCell = myDoc.createElement("cell");
					elCell.setAttribute("x",((Integer)i).toString() );
					elCell.setAttribute("y",((Integer)j).toString() );
					//elCell.setAttribute("store","false" );
					//elCell.setAttribute("box","false" );
					//elCell.setAttribute("man","false" );
					IFreeCell freeCell = (IFreeCell)cell;
					IEntity entity = freeCell.entity();
					if (freeCell.isStore()) {
						elCell.setAttribute("store","true" );
					}
					if (entity instanceof IBox) {
						elCell.setAttribute("box","true" );
					}
					if (entity instanceof IMan) {
						elCell.setAttribute("man","true" );
					}
					myDoc.getDocumentElement().appendChild(elCell);
				}
			}				
		}// for'
	}//setDocBoard
}
