package org.amse.mARICa.model.impl;

import org.amse.mARICa.model.IBoard;
import org.amse.mARICa.model.IBox;
import org.amse.mARICa.model.ICell;
import org.amse.mARICa.model.IFreeCell;
import org.amse.mARICa.model.IWall;

public class Board implements IBoard {
	
	/**
	 *  ,  
	 *      ICell
	 */
	private ICell[][] myCells;
	
	/**
	 *   ,    
	 * @param height -  
	 * @param width -  
	 */
	public Board (int height, int width){
		myCells = new ICell[height][width];
	}
	

	public ICell getCell(int x, int y) {
		if ((x < 0) || (y < 0) || (x >= myCells.length) || (y >= myCells[0].length)) {
			return null;
		}
		return myCells[x][y];
	}

	public boolean isValid() {
		int emptyStores = 0;
		for (int i = 0; i < myCells.length; i++) {
			for (int j = 0; j < myCells[0].length; j++) {
				if (myCells[i][j] instanceof IWall) {//  
					//      
					if ((getCell(i - 1, j) == null) &&
						(getCell(i + 1, j) == null) &&
						(getCell(i, j - 1) == null) &&
						(getCell(i, j + 1) == null)) {
						return false;
					}
				} else if (myCells[i][j] instanceof IFreeCell) { //  
					//    
					if (((FreeCell)myCells[i][j]).isStore()) {
						++emptyStores;
					}
					if (((FreeCell)myCells[i][j]).entity()instanceof IBox) {
						--emptyStores;
					}
						
					if ((getCell(i - 1, j - 1) == null) ||
						(getCell(i - 1, j    ) == null) ||
						(getCell(i - 1, j + 1) == null) ||
						(getCell(i    , j + 1) == null) ||
						(getCell(i + 1, j + 1) == null) ||
						(getCell(i + 1, j    ) == null) ||
						(getCell(i + 1, j - 1) == null) ||
						(getCell(i    , j - 1) == null)) {
						return false;
					}
				}	
			}
		}
		return emptyStores == 0;
	}
	
	public IFreeCell setFreeCell(int x, int y) {
		IFreeCell cell = new FreeCell();
		myCells[x][y] = cell;
		return cell;
	}

	public IWall setWall(int x, int y) {
		IWall cell = new Wall();
		myCells[x][y] = cell;
		return cell;
	}

	public int getHeight() {
		return myCells.length;
	}

	public int getWidth() {
		return myCells[0].length;
	}
}
