package org.amse.mARICa.view;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL;

import javax.swing.*;
import javax.swing.border.EtchedBorder;
import javax.swing.filechooser.FileFilter;

import org.amse.mARICa.model.*;
import org.amse.mARICa.game.*;
import org.amse.mARICa.game.Point;
import org.amse.mARICa.ioXML.*;
import org.amse.mARICa.ioXML.Reader;


public class View extends JFrame{

	private static final long serialVersionUID = 1L;

	public static void main(String[] arg) {
		new View();
	}
	/**
	 * ,     
	 */
	private BoardPanel myBoardPanel;
	/**
	 * Label,     
	 */
	private JLabel StepLabel;
	/**
	 *  
	 */
	private IBoard myBoard;
	/**
	 *   
	 */
	private IGame myGame;
	/**
	 *  ,     
	 */
	private String myNameFileOfBoard;
	/**
	 *     - 
	 *    
	 */
	private int minNeedStep;
	/**
	 *  
	 */
	private boolean myWin;
	
	/**
	 *   Action
	 */
	private java.util.List<Action> myAction = new ArrayList<Action>();
	
	private JFileChooser myFileChooser = new JFileChooser(); 
    /**
     *  
     *      
     *   Game
     */
	private void createBoard(Reader reader){
		DataForGame data = reader.setBoardFromDoc();
		myBoard = data.getBoard();
		if (!myBoard.isValid()){
			throw new ReaderException(" !") ;
		}
//		int countStores = data.getCountStores();
		Point Stores [] = data.getStores();
		Point startPos = data.getStartPos();
		minNeedStep = data.getMinStep();
		myWin = false;
		myGame = new Game (myBoard, Stores, startPos);
	}
	/**
	 *  Reader   ,    ,
	 *   JARa
	 * @param fileName -  
	 * @return Reader
	 */
	private Reader getReaderForCreatingBoardOnString(String fileName){
		return new Reader(new File(fileName));
	}
	/**
	 *  Reader   ,    ,
	 *   JARa
	 * @param fileName -  
	 * @return Reader
	 */
	private Reader getReaderForCreatingBoardOnURL(String fileName){
		return new Reader(View.class.getClassLoader().getResourceAsStream(fileName));
	}
	
	private View(){
		super(" ");
		myNameFileOfBoard = "boardDefault.clv";
		createBoard(getReaderForCreatingBoardOnURL(myNameFileOfBoard));
		setIconImage(new ImageIcon(View.class.getClassLoader().getResource("images/icon.png")).getImage());
		
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		//   
		JMenuBar MenuBar = new JMenuBar();
		//  
		MenuBar.add(createGameMenu());
		MenuBar.add(createHelpMenu());
		//     
		setJMenuBar(MenuBar);
		//      
		//    

		JPanel ContentPanel = new JPanel();
		ContentPanel.setLayout(new BorderLayout());
		//,     
		myBoardPanel = new BoardPanel(myBoard, myBoard.getHeight(),myBoard.getWidth());
		JPanel StepPanel = new JPanel();
		StepLabel = new JLabel("0");
		StepPanel.add(new JLabel(" "));
		StepPanel.add(StepLabel);
		StepPanel.add(new JLabel(" "));
		ContentPanel.add(StepPanel, BorderLayout.SOUTH);
		ContentPanel.add(myBoardPanel, BorderLayout.CENTER);
		//    
		setContentPane(ContentPanel);
		
		addWindowListener(new ExitAction());
		addKeyListener(new KeyL() );
				
		updateActions();

		setSize(700,600);
		setVisible(true);
	}
	
	private JMenuItem createMenuItem(Action action) {
		myAction.add(action);
		return new JMenuItem(action);
	}

	//  
	private JMenu createGameMenu(){
		JMenu game = new JMenu("");
		game.setMnemonic('');
		//   
		//   
		JMenu openBoard = new JMenu("..");
		openBoard.add(createMenuItem(new OpenBoardNAction(" 0")));
		openBoard.add(createMenuItem(new OpenBoardNAction(" 1")));
		openBoard.add(createMenuItem(new OpenBoardNAction(" 2")));
		openBoard.addSeparator();
		openBoard.add(createMenuItem(new OpenAction()));
		game.add(openBoard);
		game.add(createMenuItem(new OverAgainAction()));
		game.addSeparator();
		game.add(createMenuItem(new UndoAction()));
		game.add(createMenuItem(new RedoAction()));
		game.addSeparator();
		game.add(new BestResultsAction());
		game.addSeparator();
		game.add(new ExitAction());
		return game;		
	}

	void updateActions() {
		for (Action action : myAction) {
			action.setEnabled(action.isEnabled());
		}
	}

	//  
	private JMenu createHelpMenu(){
		//   
		JMenu help = new JMenu("");
		help.setMnemonic('');
		JMenuItem rules = new JMenuItem ("");
		rules.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1, 0 ));
		rules.addActionListener(new ActionListener(){
			public void  actionPerformed(ActionEvent e){
				;//   
				JDialog rules = new JDialog(View.this, "",false);
				JPanel rulePanel = new JPanel();
				rulePanel.setLayout(new FlowLayout());
				ImageIcon ruleIcon = new ImageIcon(View.class.getClassLoader().getResource("images/rule.gif")); 
				rulePanel.add(new JLabel(ruleIcon));
				rules.setContentPane(rulePanel);
				rules.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
				rules.pack();
				rules.setLocation(View.this.getWidth()/2 - rules.getWidth()/2, View.this.getHeight()/2 - rules.getHeight()/2);
				rules.setVisible(true);				
			}
		});
		JMenuItem about = new JMenuItem (" ");
		
		about.addActionListener(new ActionListener(){
			public void  actionPerformed(ActionEvent e){
				//     
				URL urlIconAbout = View.class.getClassLoader().getResource("images/iconAbout.jpg");
				JOptionPane.showMessageDialog(
						View.this,
						new String[]{"  -   "," !  v1.0"},
						" ",
						JOptionPane.INFORMATION_MESSAGE,
						new ImageIcon(urlIconAbout) );
			}
		});
		//  
		help.add(rules);
		help.add(about);
		return help;
	}
	
	class OpenAction extends AbstractAction{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		OpenAction() {
			putValue(NAME, "..");
			putValue(MNEMONIC_KEY, new Integer('') );//  
			putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('O', KeyEvent.CTRL_MASK));
		}
		public void actionPerformed(ActionEvent arg0) {
			int res = 0;
			if (!myWin){
				UIManager.put("OptionPane.noButtonText", " ");
				UIManager.put("OptionPane.yesButtonText", "");
				URL urlXmm = View.class.getClassLoader().getResource("images/icon_mega_kaugummi.gif");
				res = JOptionPane.showConfirmDialog(
						View.this,
						"   ?",
						"  .",
						JOptionPane.YES_NO_OPTION,
						JOptionPane.WARNING_MESSAGE,
						new ImageIcon(urlXmm));
			}
			if (myWin || res == JOptionPane.YES_OPTION){
				myFileChooser.setDialogTitle(" ");
				myFileChooser.setCurrentDirectory(new File("."));
				myFileChooser.addChoosableFileFilter(new LabyrinthFilesFilter());
				res = myFileChooser.showOpenDialog(View.this);
				if (res == JFileChooser.APPROVE_OPTION){
					myNameFileOfBoard = myFileChooser.getSelectedFile().getName();
					try{
						createBoard(getReaderForCreatingBoardOnString(myNameFileOfBoard));
						myBoardPanel.setBoard(myBoard, myBoard.getHeight(),myBoard.getWidth());
						StepLabel.setText("0");
						myBoardPanel.repaint();
					}catch (ReaderException e){
						JOptionPane.showMessageDialog(
								View.this,
								"     !",
								" ",							
								JOptionPane.ERROR_MESSAGE);
					}
				}
			}
		}
	}
	
	class OpenBoardNAction extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		private String myName;
		private char myACCELERATOR_KEY;
		/**
		 *   ,   , 
		 * @param name -  Item
		 * @return
		 */
		private String changerNameFileOnNameItem(String name){
			if (name == " 0"){
				myACCELERATOR_KEY = '0';
				return "boardDefault.clv";
			}
			if (name == " 1"){
				myACCELERATOR_KEY = '1';
				return "board1.clv";
			}
			if (name == " 2"){
				myACCELERATOR_KEY = '2';
				return "board2.clv";
			}
			return null;
		}
		OpenBoardNAction(String name) {
			myName = changerNameFileOnNameItem(name);
			putValue(NAME, name);
			putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(myACCELERATOR_KEY, KeyEvent.CTRL_MASK));
		}
		public void actionPerformed(ActionEvent arg0) {
			int res = 0;
			if (!myWin){
				UIManager.put("OptionPane.noButtonText", " ");
				UIManager.put("OptionPane.yesButtonText", "");
				URL urlXmm = View.class.getClassLoader().getResource("images/icon_mega_kaugummi.gif");
				res = JOptionPane.showConfirmDialog(
					View.this,
					"   ?",
					"  .",
					JOptionPane.YES_NO_OPTION,
					JOptionPane.WARNING_MESSAGE,
					new ImageIcon(urlXmm));
			}
			if (myWin || res == JOptionPane.YES_OPTION){
				myNameFileOfBoard = myName;
				try{
					createBoard(getReaderForCreatingBoardOnURL(myNameFileOfBoard));
					myBoardPanel.setBoard(myBoard, myBoard.getHeight(),myBoard.getWidth());
					StepLabel.setText("0");
					myBoardPanel.repaint();
				}catch (ReaderException e){
					JOptionPane.showMessageDialog(
							View.this,
							"     !",
							" ",							
							JOptionPane.ERROR_MESSAGE);
				}
			}
		}
	}
	
	class OverAgainAction extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		OverAgainAction() {
			putValue(NAME, " ");
			putValue(MNEMONIC_KEY, new Integer('') );//  
			putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('R', KeyEvent.CTRL_MASK));
		}

		public void actionPerformed(ActionEvent event) {
			int res = 0;
			if (!myWin){
				UIManager.put("OptionPane.noButtonText", " ");
				UIManager.put("OptionPane.yesButtonText", "");
				URL urlXmm = View.class.getClassLoader().getResource("images/icon_mega_kaugummi.gif");
				res = JOptionPane.showConfirmDialog(
						View.this,
						"   ??",
						"  .",
						JOptionPane.YES_NO_OPTION,
						JOptionPane.WARNING_MESSAGE,
						new ImageIcon(urlXmm));
			}
			if (myWin || res == JOptionPane.YES_OPTION){
				if (myNameFileOfBoard.endsWith(".clv")){
					createBoard(getReaderForCreatingBoardOnURL(myNameFileOfBoard));
				}else{				
					createBoard(getReaderForCreatingBoardOnString(myNameFileOfBoard));
				}
				myBoardPanel.setBoard(myBoard, myBoard.getHeight(),myBoard.getWidth());
				StepLabel.setText("0");
				myBoardPanel.repaint();
			}			
		}
	}
	
	class LabyrinthFilesFilter extends FileFilter{
		public boolean accept(File file){
			if (file.isDirectory())
				return true;
			return (file.getName().endsWith("clv"));
		}
		public String getDescription(){
			return " (*.clv)";
		}
	}
	
	class UndoAction extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		UndoAction() {
			putValue(NAME, "");
			putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('Z', KeyEvent.CTRL_MASK));
		}
		public boolean isEnabled() {
			return myGame.canUndo();
		}
		public void actionPerformed(ActionEvent event) {
			myGame.unDo();
			updateActions();
			StepLabel.setText(((Integer)myGame.getCountStep()).toString());
			myBoardPanel.repaint();
		}
	}
	
	class RedoAction extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		RedoAction() {
			putValue(NAME, "");
			putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke('Y', KeyEvent.CTRL_MASK));
		}
		public boolean isEnabled() {
			return myGame.canRedo();			 
		}
		public void actionPerformed(ActionEvent event) {
			myGame.reDo();
			updateActions();
			StepLabel.setText(((Integer)myGame.getCountStep()).toString());
			myBoardPanel.repaint();
		}
	}
	
	class BestResultsAction extends AbstractAction {
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		BestResultsAction() {
			putValue(NAME, " ");
		}
		public void actionPerformed(ActionEvent event) {
			setBestResuls(0);
		}
	}
	
	class ExitAction extends AbstractAction implements WindowListener{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		ExitAction() {
			putValue(NAME, "");
			putValue(ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_F4, KeyEvent.ALT_MASK));
		}
		
		public void actionPerformed(ActionEvent event) {
			if (myWin){
				System.exit(0);
				return;
			}
			UIManager.put("OptionPane.noButtonText", " ");
			UIManager.put("OptionPane.yesButtonText", "");
			URL urlBuu = View.class.getClassLoader().getResource("images/icon_cry.gif");
			int res = JOptionPane.showConfirmDialog(
				View.this,
				"  ??",
				"  .",
				JOptionPane.YES_NO_OPTION,
				JOptionPane.WARNING_MESSAGE,
				new ImageIcon(urlBuu));
			if (res == JOptionPane.YES_OPTION){
				setBestResuls(0);
				System.exit(0);					
			}
		}
		public void windowActivated(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}
		public void windowClosed(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}
		public void windowClosing(WindowEvent arg0) {
			actionPerformed(null);			
		}
		public void windowDeactivated(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}
		public void windowDeiconified(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}
		public void windowIconified(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}
		public void windowOpened(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}
	}
	
	class KeyL implements KeyListener{

		public void keyReleased(KeyEvent arg0) {
			// TODO Auto-generated method stub			
		}

		public void keyPressed(KeyEvent key) {
			if (myWin) {
				return;
			}
			switch (key.getKeyCode()){
				case KeyEvent.VK_LEFT:
					moveOneStep( Direction.LEFT);
					break;
				case KeyEvent.VK_RIGHT:
					moveOneStep( Direction.RIGHT);
					break;
				case KeyEvent.VK_DOWN:
					moveOneStep( Direction.DOWN);
					break;
				case KeyEvent.VK_UP:
					moveOneStep( Direction.UP);
					break;	
			}
			StepLabel.setText(((Integer)myGame.getCountStep()).toString());
			View.this.updateActions();
			myBoardPanel.repaint();
			if (myWin)
				setBestResuls(winner());
		}

		public void keyTyped(KeyEvent arg0) {
			// TODO Auto-generated method stub			
		}		
	}
	
	/**
	 *    1 ,   
	 *   dir
	 * @param dir
	 */
	private void moveOneStep(Direction dir){
		if (myGame.canGo(dir) >= 0){
			myBoardPanel.setDirMan(dir);
			if (myGame.canGo(dir) > 0){
				 if (myGame.goBox(dir)){
					if (myGame.isAllBoxOnStore())
						myWin = true;
				 }
			}//myGame.canGo(dir) == 0  
			myGame.goMan(dir);
		}
	}
	
	private int points(int countStep){
		return minNeedStep * 100 / countStep;
	}
	
	private int winner(){
		int countStep = points(myGame.getCountStep()) ;
		JOptionPane.showMessageDialog(
				View.this, 
				new String[]{"!!     !",
						(new StringBuffer("  " + countStep + " ")).toString()}, 
				"", 
				JOptionPane.INFORMATION_MESSAGE,
				new ImageIcon(View.class.getClassLoader().getResource("images/icon_daumenhoch.gif")));	
		return countStep;
	}
	
	private void writeDefaultScore(){
		ArrayList<Score> arrScore = new ArrayList<Score>();
		arrScore.add(0, new Score("Clever mool","5"));
		arrScore.add(1, new Score("Clever mool","4"));
		arrScore.add(2, new Score("Clever mool","3"));
		arrScore.add(3, new Score("Clever mool","2"));
		arrScore.add(4, new Score("Clever mool","1"));
		try{
			AbstractWriter writer = new ScoresWriter(arrScore);
			writer.writeXmlFile("scores.dat");
		}catch (WriterException e){
			throw new WriterException(" ");
		}
	}
	
	private void setBestResuls(int countStep){
		// countStep<min(BestResults)   
		try{
			File fileScores = new File("scores.dat");
			if (!fileScores.exists()){//         reader
				writeDefaultScore();
			}
			Reader reader = new Reader(fileScores);
			ArrayList<Score> scores = reader.setScoresFromDoc();
			String score = scores.get(scores.size()-1).getScore();
			if ( new Integer(score).intValue() <= countStep ){
			//  
			UIManager.put("OptionPane.cancelButtonText", "");
			String name = (String) JOptionPane.showInputDialog(
					View.this,
					new String[]{"     .","  "},
					" ",
			 		JOptionPane.QUESTION_MESSAGE,
			 		new ImageIcon(View.class.getClassLoader().getResource("images/win.gif")), 
			 		null, 
			 		null	
					);
			if (name == null || name.length() == 0){
				name = " ";
			}
			scores.add(scores.size(), new Score(name, ( (Integer)countStep).toString()));
			java.util.Collections.<Score>sort(scores);
			BestResultDialog(" ",true,scores).setVisible(true);
			AbstractWriter writer = new ScoresWriter(scores);
			writer.writeXmlFile("scores.dat");
			}else{
				BestResultDialog(" ",true,scores).setVisible(true);
			}
		}catch (ReaderException e){
			JOptionPane.showMessageDialog(
					View.this,
					"   scores.dat",
					" ",							
					JOptionPane.ERROR_MESSAGE);
		}catch (WriterException e){
			JOptionPane.showMessageDialog(
					View.this,
					"    scores.dat",
					" ",							
					JOptionPane.ERROR_MESSAGE);
		}
	}
	
	private JDialog BestResultDialog(String title, boolean modal, ArrayList<Score> scores){
		final JDialog dialog = new JDialog(View.this, title,modal);
		dialog.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		JPanel contentPanel = new JPanel();
		contentPanel.setBorder(BorderFactory.createEmptyBorder(12, 12, 12, 12));
		contentPanel.setLayout(new BoxLayout(contentPanel,BoxLayout.Y_AXIS));
		
		JPanel labelPanel = new JPanel();
		labelPanel.setLayout(new GridLayout(5,2,30,3));
		for(int i=0; i < 5; i++){
			labelPanel.add(new JLabel(""+ (i+1) + "  " + scores.get(i).getName()));
			JLabel Lscore = new JLabel("<html> <font align=\"right\">" + scores.get(i).getScore());
			labelPanel.add(Lscore);
		}
		labelPanel.setBorder(new EtchedBorder(EtchedBorder.LOWERED));
		labelPanel.setAlignmentX(JPanel.CENTER_ALIGNMENT);
		
		JButton button = new JButton("OK");
		button.setAlignmentX(JButton.CENTER_ALIGNMENT);
		button.setSize(30, 20);
		button.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				dialog.dispose();
			}			
		});
		
		contentPanel.add(labelPanel);
		contentPanel.add(Box.createVerticalStrut(5));
		contentPanel.add(button);
		dialog.setContentPane(contentPanel);
		dialog.setLocation(this.getWidth()/2 - 100, this.getHeight()/2 - 100);
		dialog.setResizable(false);
		dialog.pack();
		return dialog;
	}
} 
